# Table.py -- Pamhyr
# Copyright (C) 2023-2026  INRAE
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

# -*- coding: utf-8 -*-

import logging
import traceback

from tools import trace, timer, old_pamhyr_date_to_timestamp

from PyQt5.QtCore import (
    Qt, QVariant, QAbstractTableModel,
    QCoreApplication, QModelIndex, pyqtSlot,
    QRect,
)

from PyQt5.QtWidgets import (
    QDialogButtonBox, QPushButton, QLineEdit,
    QFileDialog, QTableView, QAbstractItemView,
    QUndoStack, QShortcut, QAction, QItemDelegate,
    QComboBox,
)

from View.LateralContribution.UndoCommand import (
    SetNameCommand, SetEdgeCommand, SetTypeCommand,
    SetBeginCommand, SetEndCommand,
    AddCommand, DelCommand, SortCommand,
    MoveCommand, PasteCommand, DuplicateCommand, ImportCommand,
)

from Model.LateralContribution.LateralContributionTypes import (
    NotDefined, LateralContrib, Rain, Evaporation,
)

from View.Tools.PamhyrTable import PamhyrTableModel
from View.LateralContribution.translate import LC_types

logger = logging.getLogger()

_translate = QCoreApplication.translate


class ComboBoxDelegate(QItemDelegate):
    def __init__(self, data=None, mode="type", tab="",
                 trad=None, parent=None):
        super(ComboBoxDelegate, self).__init__(parent)

        self._data = data
        self._mode = mode
        self._tab = tab
        self._trad = trad

    @property
    def data(self):
        return self._data

    @data.setter
    def data(self, data):
        self._data = data

    def createEditor(self, parent, option, index):
        self.editor = QComboBox(parent)
        long_types = self._trad.get_dict("long_types")

        if self._mode == "type":
            lst = list(
                map(
                    lambda k: long_types[k],
                    filter(
                        lambda k: self._tab in LC_types[k].compatibility(),
                        LC_types.keys()
                    )
                )
            )
            self.editor.addItems(lst)
        elif self._mode == "rk":
            if self._data is None:
                self.editor.addItems(
                    ["-"]
                )
            else:
                self.editor.addItems(
                    list(
                        map(
                            lambda p: p.display_name(),
                            self._data.reach.profiles
                        )
                    )
                )
        else:
            self.editor.addItems(
                [self._trad['not_associated']] +
                self._data.edges_names()
            )

        self.editor.setCurrentText(index.data(Qt.DisplayRole))
        return self.editor

    def setEditorData(self, editor, index):
        value = index.data(Qt.DisplayRole)
        self.editor.currentTextChanged.connect(self.currentItemChanged)

    def setModelData(self, editor, model, index):
        text = str(editor.currentText())

        if self._data is None:
            value = text
        else:
            if self._mode == "rk" and self._data.reach is not None:
                profiles = list(
                    filter(
                        lambda p: p.display_name() == text,
                        self._data.reach.profiles
                    )
                )

                value = profiles[0].pamhyr_id if len(profiles) > 0 else None
            else:
                value = text

        model.setData(index, value)
        editor.close()
        editor.deleteLater()

    def updateEditorGeometry(self, editor, option, index):
        r = QRect(option.rect)
        if self.editor.windowFlags() & Qt.Popup:
            if editor.parent() is not None:
                r.setTopLeft(self.editor.parent().mapToGlobal(r.topLeft()))
        editor.setGeometry(r)

    @pyqtSlot()
    def currentItemChanged(self):
        self.commitData.emit(self.sender())


class TableModel(PamhyrTableModel):
    def _setup_lst(self):
        self._lst = self._data.lateral_contribution
        self._tab = self._opt_data
        self._long_types = self._trad.get_dict("long_types")

    def get_true_data_row(self, row):
        lc = self._lst.get(self._tab, row)

        return next(
            map(
                lambda e: e[0],
                filter(
                    lambda e: e[1] == lc,
                    enumerate(self._lst.get_tab(self._tab))
                )
            ), 0
        )

    def rowCount(self, parent):
        return self._lst.len(self._tab)

    def data(self, index, role):
        if role != Qt.ItemDataRole.DisplayRole:
            return QVariant()

        row = index.row()
        column = index.column()

        if self._headers[column] == "name":
            return self._lst.get(self._tab, row).name
        elif self._headers[column] == "type":
            t = self._lst.get(self._tab, row).lctype
            return self._long_types[t]
        elif self._headers[column] == "edge":
            n = self._lst.get(self._tab, row).reach
            if n is None:
                return self._trad['not_associated']
            return n.name
        elif self._headers[column] == "begin_rk":
            return str(self._lst.get(self._tab, row).begin_rk)
        elif self._headers[column] == "end_rk":
            return str(self._lst.get(self._tab, row).end_rk)

        return QVariant()

    def setData(self, index, value, role=Qt.EditRole):
        if not index.isValid() or role != Qt.EditRole:
            return False

        if self.is_same_data(index, value):
            return False

        row = index.row()
        column = index.column()

        try:
            if self._headers[column] == "name":
                self._undo.push(
                    SetNameCommand(
                        self._lst, self._tab, row, value
                    )
                )
            elif self._headers[column] == "type":
                key = next(k for k, v in self._long_types.items()
                           if v == value)
                self._undo.push(
                    SetTypeCommand(
                        self._lst, self._tab, row, LC_types[key]
                    )
                )
            elif self._headers[column] == "edge":
                self._undo.push(
                    SetEdgeCommand(
                        self._lst, self._tab, row, self._data.edge(value)
                    )
                )
            elif self._headers[column] == "begin_rk":
                _edge = self._lst.get(self._tab, row).reach
                _begin_rk = next(
                    p for p in _edge.reach.profiles
                    if p.pamhyr_id == value
                )
                self._undo.push(
                    SetBeginCommand(
                        self._lst, self._tab, row, _begin_rk
                    )
                )
            elif self._headers[column] == "end_rk":
                _edge = self._lst.get(self._tab, row).reach
                _end_rk = next(
                    p for p in _edge.reach.profiles
                    if p.pamhyr_id == value
                )
                self._undo.push(
                    SetEndCommand(
                        self._lst, self._tab, row, _end_rk
                    )
                )
        except Exception as e:
            logger.info(e)
            logger.debug(traceback.format_exc())

        self.dataChanged.emit(index, index)
        return True

    def add(self, row, parent=QModelIndex()):
        self.beginInsertRows(parent, row, row - 1)

        row = self.get_true_data_row(row)

        self._undo.push(
            AddCommand(
                self._lst, self._tab, row
            )
        )

        self.endInsertRows()
        self.layoutChanged.emit()

    def delete(self, rows, parent=QModelIndex()):
        self.beginRemoveRows(parent, rows[0], rows[-1])

        rows = list(
            map(
                lambda r: self.get_true_data_row(r),
                rows
            )
        )

        self._undo.push(
            DelCommand(
                self._lst, self._tab, rows
            )
        )

        self.endRemoveRows()
        self.layoutChanged.emit()

    def sort(self, _reverse, parent=QModelIndex()):
        self.layoutAboutToBeChanged.emit()

        self._undo.push(
            SortCommand(
                self._lst, self._tab, False
            )
        )

        self.layoutAboutToBeChanged.emit()
        self.layoutChanged.emit()

    def move_up(self, row, parent=QModelIndex()):
        if row <= 0:
            return

        target = row + 1

        self.beginMoveRows(parent, row - 1, row - 1, parent, target)

        row = self.get_true_data_row(row)

        self._undo_stack.push(
            MoveCommand(
                self._lst, self._tab, "up", row
            )
        )

        self.endMoveRows()
        self.layoutChanged.emit()

    def move_down(self, index, parent=QModelIndex()):
        if row > len(self._lst):
            return

        target = row

        self.beginMoveRows(parent, row + 1, row + 1, parent, target)

        row = self.get_true_data_row(row)

        self._undo_stack.push(
            MoveCommand(
                self._lst, self._tab, "down", row
            )
        )

        self.endMoveRows()
        self.layoutChanged.emit()

    def read_from_lat(self, file_name):
        logger.debug(f"Import lateral contributions from {file_name}")
        data = []
        current_reach = -1
        with open(file_name, encoding="utf-8") as lat_file:
            for line in lat_file:
                if not (line.startswith("#") or
                        line.startswith("*") or
                        len(line) < 1):
                    line = line.split()
                    if line[0] == "$":
                        current_reach = int(line[1]) - 1
                        if (current_reach <= len(self._data.enable_edges()) and
                                current_reach >= 0):
                            data.append(
                                [self._data.enable_edges()[current_reach],
                                 float(line[2]),
                                 float(line[3])
                                 ]
                            )
                    else:
                        if (current_reach <= len(self._data.enable_edges()) and
                                current_reach >= 0):
                            data[-1].append(
                                [
                                    old_pamhyr_date_to_timestamp(line[0]),
                                    float(line[1])
                                ]
                            )

        self.layoutAboutToBeChanged.emit()

        self._undo.push(
            ImportCommand(
                self._lst, self._tab, data
            )
        )

        self.layoutAboutToBeChanged.emit()
        self.layoutChanged.emit()
